# CodeIgniter Backend System

CodeIgniter Backend System helps you build a backend system of Codeigniter framework with a lot of powerful features. See my site [http://ci2backend.com](http://ci2backend.com)

# Key features
- [User management (ACL)](#user-management)
- [Multi-languages](#multi-languages)
- [Database management](#database-management)
- [Model/View/Controller management](#mvc-management)
- [Routes management](#routes-management)
- [Template management](#template-management)
- [Extension management](#extension-management)
- [Configure system settings](#configure-system-settings)

### User Management
- CRUD user 
- Set user roles

### Multi Languages
- Setting multi-languages to your system
- Add/Remove language
- CRUD translation file

### Database Management
- Rename and Reset database

### MVC Management

##### Model
- Auto-render new Model with basic actions (CRUD record)
- View and Edit directly on web layout

##### View
- Auto-render new View file and its assets (css, js files)
- You can set template and platform for the view when creating
- View and Edit directly on web layout

##### Controller
- Auto-render Controller with basic actions
- View and Edit directly on web layout

### Routes Management
- CRUD all routes of your site easily.

### Template Management
- CRUD templates
- Configure your custom template by part: header, content, footer  

### Extension Management
- Add/Remove extension which can be used in this system
- All the Extensions can be found at [Extension Store](http://www.ci2backend.com/)

### Configure System Settings
- Backup and restore database

# Benefits over manual building
- Create and integrate components, extensions automatically and quickly
- Prevent duplicates, missing files, confliction.
- Save a lot of time for creating new file or directory.

# Installation

- Download the latest version.
- Copy the files from this package to your web root directory.
- Open the browser and run www.example.com/install.php (`www.example.com` is your domain) and setup as the instruction. Make sure to pass all the required components.
- Well done!

-Username: `admin@admin.com`

-Password: `password`

# Configuration and documentation
- [Documentation](http://ci2backend.com/setup.html)

# Donations
CodeIgniter Backend System has been created by [phutv](https://plus.google.com/+vanphuTruong) and is currently maintained by him and his team. We highly appreciate any of your donations.

[![paypal](https://www.paypalobjects.com/en_US/i/btn/btn_donateCC_LG.gif)](https://www.paypal.com/cgi-bin/webscr?cmd=_s-xclick&hosted_button_id=FLHJAF2ECGXGQ)